# mypy-boto3-opsworks

[![PyPI - mypy-boto3-opsworks](https://img.shields.io/pypi/v/mypy-boto3-opsworks.svg?color=blue)](https://pypi.org/project/mypy-boto3-opsworks)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-opsworks.svg?color=blue)](https://pypi.org/project/mypy-boto3-opsworks)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-opsworks](#mypy-boto3-opsworks)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)

Type annotations for
[boto3.OpsWorks 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/opsworks.html#OpsWorks) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.4](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `OpsWorks` service.

```bash
python -m pip install boto3-stubs[opsworks]
```

Use `boto3` with `mypy_boto3_opsworks` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_opsworks import OpsWorksClient

# Now mypy can check if your code is valid.
client: OpsWorksClient = boto3.client("opsworks")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: OpsWorksClient = session.client("opsworks")

# Do you prefer resource approach? We've got you covered!
from mypy_boto3_opsworks import OpsWorksServiceResource

resource: opsworks.OpsWorksServiceResource = boto3.resource("opsworks")


# Waiters are also supported

import mypy_boto3_opsworks.waiter as opsworks_waiters

app_exists_waiter: opsworks_waiters.AppExistsWaiter = client.get_waiter("app_exists")
deployment_successful_waiter: opsworks_waiters.DeploymentSuccessfulWaiter = client.get_waiter("deployment_successful")
instance_online_waiter: opsworks_waiters.InstanceOnlineWaiter = client.get_waiter("instance_online")
instance_registered_waiter: opsworks_waiters.InstanceRegisteredWaiter = client.get_waiter("instance_registered")
instance_stopped_waiter: opsworks_waiters.InstanceStoppedWaiter = client.get_waiter("instance_stopped")
instance_terminated_waiter: opsworks_waiters.InstanceTerminatedWaiter = client.get_waiter("instance_terminated")


# Annotated paginators are included as well

import mypy_boto3_opsworks.paginator as opsworks_paginators

describe_ecs_clusters_paginator: opsworks_paginators.DescribeEcsClustersPaginator = client.get_paginator("describe_ecs_clusters")
```

## Dynamic type annotations

`mypy_boto3` command generates `boto3.client/resource` type annotations for
`mypy_boto3_opsworks` and other installed services.

```bash
# Run this command after you add or remove service packages
python -m mypy_boto3
```

Generated type annotations provide overloads for `boto3.client` and `boto3.resource`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully if you have many services installed
- `VSCode` does not currently support function overloads, use explicit type annotations

```python
import boto3

# Type is discovered correctly by mypy and PyCharm
# VSCode still needs explicit type annotations
client = boto3.client("opsworks")
resource = boto3.resource("opsworks")

session_client = boto3.Session().client("opsworks")
session_resource = boto3.Session().resource("opsworks")
```